[![Build Status](https://travis-ci.com/dm4t2/vue-currency-input.svg?branch=master)](https://travis-ci.com/dm4t2/vue-currency-input)
[![codecov](https://codecov.io/gh/dm4t2/vue-currency-input/branch/master/graph/badge.svg)](https://codecov.io/gh/dm4t2/vue-currency-input)
[![npm version](https://badge.fury.io/js/vue-currency-input.svg)](https://badge.fury.io/js/vue-currency-input)
![](https://img.shields.io/npm/l/vue-currency-input.svg)

# Vue Currency Input
The Vue Currency Input plugin allows an easy input of currency formatted numbers. It provides both a standalone component (`<currency-input>`) and a custom Vue directive (`v-currency`) for decorating existing input components with currency format capabilities.

[Read the guide](https://dm4t2.github.io/vue-currency-input/guide/) to getting started or check out the [examples](https://dm4t2.github.io/vue-currency-input/examples/) to see it in action.

## Features

### Lightweight
Only [~3 kB bundle size](https://bundlephobia.com/result?p=vue-currency-input) (minified + gzipped) and zero dependencies.

### Format as you type
Numbers are formatted immediately during input.

### i18n support
Language-dependent, ISO-compliant currency formatting using the native [Intl.NumberFormat](https://developer.mozilla.org/de/docs/Web/JavaScript/Reference/Global_Objects/NumberFormat).

### Auto decimal mode
Automatically insert the decimal symbol and use the last inputted digits as decimal digits.

### Distraction free
Automatically hide the formatting and negligible decimal digits on focus.

## Support me
If you find this plugin helpful or you want to support the development, buy me a coffee:

[![ko-fi](https://www.ko-fi.com/img/githubbutton_sm.svg)](https://ko-fi.com/D1D6SXEA)
