import './utils/extensions'
import gazelComponents from './components'
import { registerComponents } from './utils/plugins'

import { appStart } from './app-start'
import { registerForkedPlugins } from './forked-plugins'

export function install(Vue, options = {}) {
        if (install.installed) return;
        install.installed = true;

        appStart(Vue, options);

        registerForkedPlugins();
        registerComponents(Vue, gazelComponents)
}

const GazelVue = { install };

export default GazelVue;

let GlobalVue = null;
if (typeof window !== 'undefined') {
        GlobalVue = window.Vue;
} else if (typeof global !== 'undefined') {
        GlobalVue = global.Vue;
}
if (GlobalVue) 
{ 
  GlobalVue.use(GazelVue); 
}
