import { gazelConfig } from './../../../utils/config'

const initialise = ({commit})=>{
    commit('INITIALISE');
}

const setLanguages = async ({commit}) => {
    if(!Vue.prototype.$localStorage.get(window.$gazelConstants.Store.LANGUAGE) || JSON.parse(Vue.prototype.$localStorage.get(window.$gazelConstants.Store.LANGUAGE)).all.length == 0){
      commit('SET_LANGUAGES', await gazelConfig.localization.languages());       
    }
    else{
      commit('SET_LANGUAGES', JSON.parse(Vue.prototype.$localStorage.get(window.$gazelConstants.Store.LANGUAGE)).all);      
    }
}

const setCurrentLanguage = ({commit, state}, language) => {
    if(!language){
      if(!Vue.prototype.$localStorage.get(window.$gazelConstants.Store.LANGUAGE) || _.isUndefined(JSON.parse(Vue.prototype.$localStorage.get(window.$gazelConstants.Store.LANGUAGE)).currentLanguage)){
        language = state.all.find(sl=>sl.specificCultureName == gazelConfig.localization.default);
        if(_.isUndefined(language)){  
          language = state.all.find(sl => navigator.languages.find(l => (l.toLowerCase().split(new RegExp(sl.languageCode.toLowerCase(), 'gi')).length - 1 > 0 ? sl : null)));
          if(_.isUndefined(language)){
             language = _.head(state.all)
          }
        }
      }
      else{
        language = JSON.parse(Vue.prototype.$localStorage.get(window.$gazelConstants.Store.LANGUAGE)).currentLanguage
      }
    }
    commit('SET_CURRENT_LANGUAGE', language);
}

export default {
    initialise,
    setLanguages,
    setCurrentLanguage
}

