import _ from 'lodash';
import { gazelConfig } from './../../../utils/config';

const initialise = async ({commit}) => {
    commit('INITIALISE');
}

const setLocalizationText = async ({ commit }, language)=>  {
    let localizationTexts = [];
    const languageCode = language.languageCode.toLowerCase();
    if(!Vue.prototype.$localStorage.get($gazelConstants.Store.LOCALIZATION_TEXT) || _.isEmpty(JSON.parse(Vue.prototype.$localStorage.get($gazelConstants.Store.LOCALIZATION_TEXT)).localizationTexts[languageCode])){
        const result = await gazelConfig.localization.texts(language.languageCode);
        localizationTexts = _.mapValues(_.keyBy(_.map(result, r => _.pick(r, ['textKey', 'value'])),'textKey'), function(l){ return l.value; });
    }
    else{
        localizationTexts = JSON.parse(Vue.prototype.$localStorage.get($gazelConstants.Store.LOCALIZATION_TEXT)).localizationTexts[languageCode];
    }
    commit('SET_LOCALIZATION_TEXT', {languageCode, localizationTexts});
}

export default {
    initialise,
    setLocalizationText
}